/**********
* utils.c *
**********/

/* $Id: utils.c,v 0.5 1995/03/26 00:47:02 sharl Exp sharl $ */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "sys.h"

char *
xmalloc(len)
size_t len;
{
  char *p;

  p = malloc(len);
  if (p == NULL) {
    perror(progname);
    exit(1);
  }
  return p;
}

char *
xstrdup(str)
const char *str;
{
  char *p;

#ifdef HAVE_STRDUP
  if ((p = strdup(str)) == NULL) {
    perror(progname);
    exit(1);
  }
  return p;
#else
  p = xmalloc(strlen(str) + 1);
  strcpy(p, str);
  return p;
#endif
}

char *
getnode(fname)
const char *fname;
{
  char *p, *pp;

  pp = xstrdup(fname);
  if ((p = jstrrchr(pp, '\\')) != NULL)
    pp = p + 1;
  if ((p = jstrrchr(pp, '/')) != NULL)
    pp = p + 1;
  if ((p = jstrrchr(pp, ':')) != NULL)
    pp = p + 1;
  if ((p = jstrrchr(pp, '.')) != NULL)
    *p = '\0';
  return pp;
}

char *
gettrunk(fname)
const char *fname;
{
  char *p, *name;

  name = xstrdup(fname);
  if ((p = jstrrchr(name, '/')) != NULL)
    *(p + 1) = '\0';
  else if ((p = jstrrchr(name, '\\')) != NULL)
    *(p + 1) = '\0';
  else
    return "";
  return name;
}
